/*							*/
/*	D-STAR room server  Control Program	 	*/
/*      	    V00.00  09/22/2011                  */
/*  				Satoshi Yasuda		*/
/*				7m3tjz/ad6gz		*/
/*                              	                */


#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
#include <windows.h>
#include <assert.h>
#include <time.h>
#include "node.h"
#include "dstar.h"

#define FALSE   0
#define TRUE    1

#define	VOICE_PORT	39998	/* default Voice UDP port */
#define	CONTROL_PORT		39999	/* default control port   */

#define	hostname1	"node.jk1zrw.org"
#define	hostname2	"ns.jk1zrw.org"
#define	hostname3	"www.d-star.asia"
#define AccessCtrl      "callsign.txt"

#define VersionHigh	0x00
#define VersionLow	0x00

struct	search_table *first_pnt;	

SOCKET	recv_sock, send_sock, db_sock;
u_long	out_ip, host_ip, from_ip, keep_from_ip;
char	MyNodeCall[8] = {"DIRECT  "};
char	server1[128] = {hostname1};
char	server2[128] = {hostname2};
char	server3[128] = {hostname3};
char	busyfile[128];
char	notfoundfile[128];
char	invalidfile[128];
char	audiodir[128];
char	accessctrl[128] = {AccessCtrl};
int	info, debug, PICinfo, RFinfo, Notice, NodeCallCheck, NodeOn, DprsSW, CrcSW;
char	lastframe1[3] ={0x55,0x55,0x55};
char	lastframe2[3] ={0x55,0xc8,0x7a};
char 	buffer[32];
char 	status;
unsigned char slow_data_buf[6];
struct	sockaddr_in from;
struct	sockaddr_in addr_db;
struct	sockaddr_in addr_out;
int 	ret, LastFrameSW;
fd_set	readfd;
int	max_wait_sec = 15;
int	max_keep_alive = 10;
int	maxPTTkeepalive = 20;
int	PTTkeepalive = 0;
int	PTT_ON;
int	slow_data_sw;
HANDLE	dprscomport;
DCB	dcb;
int	ok, baud_rate;
int	voice_port = {VOICE_PORT};
int	db_port ={DB_PORT};
char	*cfg_file;

int	HeaderLength;
struct	timeval	tv;

WSADATA wsaData;
struct	sockaddr_in addr_in;
struct	hostent *p_ent;
struct in_addr *p_in_addr;

int	sync;
int	ssn;

void main(int argc, const char **argv) {
	int	i,k;

	unsigned char	ssn_temp[2];

	signal (SIGINT, ctrl_c);
	signal (SIGBREAK, ctrl_c);

	print_version();

	info = FALSE;
	debug = FALSE;
	Notice = FALSE;
	NodeCallCheck = FALSE;
	NodeOn = TRUE;
	CrcSW = FALSE;
	slow_data_sw = FALSE;
	cfg_file = NULL;
	first_pnt = NULL;
	send_dv.udp_p.b_bone.seq_low = 0xff;
	sync = 0;
	PTT_ON = FALSE;


	if (argc >= 2) option_set (argc, (char **)argv);

	if (debug) printf ("                      debug mode\n");
	cfg_read(cfg_file);

	if (strncmp(MyCall, "DIRECT  ", 8) && info) printf ("Node CallSign : %.8s\n",MyNodeCall);

	Inet_SetUp();

	LastFrameSW = 0;	
	memset(&send_dv, 0, 56);
	strncpy (send_dv.udp_p.id,"DVND",4);

	JitterBufferInit();

	from_ip = 0;
	keep_from_ip = 0;
	printf ("START TIME %.24s\n",curtime());
	

/*		*/
/*    loop 	*/
/*		*/

   while (1)
   {
	tv.tv_sec = 0;
	tv.tv_usec = 10000;		/* 25 m Sec. */

	read_from_inet (tv);		/* read from inet (udp packet) */


  }	/* end while (1) */

}

void	option_set (int argc, char **argv)
{
	int	i;

	for (i = 1 ; i < argc ; i++)
	{
		if (!strncmp (argv[i],"-d",2)) 	debug = TRUE;
		else if (!strncmp (argv[i], "-i",2)) info = TRUE;
		else if (!strncmp (argv[i], "-n",2)) Notice = TRUE;
		else if (!strncmp (argv[i], "-f",2)) cfg_file = (char *)argv[i+1];
		else if (!strncmp (argv[i], "-?",2)) usage();
	}
}

void	delete_inet_adr (unsigned char CallSign[], struct search_table *table_pnt)
{
	struct search_table *temp_pnt, *back_pnt;

	back_pnt = table_pnt;
	temp_pnt = (struct search_table *)back_pnt->forward_chain;
		
	while (temp_pnt != NULL)
	{
		if (!strncmp(CallSign, temp_pnt->d_table.CallSign, 8))
		{
			back_pnt->forward_chain = temp_pnt->forward_chain;
			free (temp_pnt);
			return;
		}
		back_pnt = temp_pnt;
		temp_pnt = (struct search_table *)temp_pnt->forward_chain;	
	}
	
	return;
}

void	ctrl_c ()
{
	struct search_table *p, *next;
	char	string[10];
	int	i;

	if (!debug)
	{
			p = first_pnt;
			while (p != NULL)
			{
				next = (struct search_table *)p->forward_chain;
				free (p);
				p = next;
			}

			delete_node_db (db_sock, addr_db, MyNodeCall);
			usb_control_msg(udev, 0x40, SET_AD_INIT, ON, 0, buffer, 0, 100);	/* reset Node Adapter */
    			usb_close(udev);
			closesocket(recv_sock);
			closesocket(send_sock);
			closesocket(db_sock);
			WSACleanup();
			printf ("\n\n\nEND TIME %s\n",curtime());
			abort();
	}

	signal (SIGINT, SIG_IGN);
	signal (SIGBREAK, SIG_IGN);
	printf ("\n*** Select Menu ***\n");
	printf ("Refresh Entry Table : 1\n");
	printf ("Show Entry Table    : 2\n");
	printf ("Abort/Exit          : 9\n");
	printf ("\n");
	printf ("Enter Select Number : ");

	gets(string);
	i = atoi(string);
	switch (i)
	{
		case 9:
			p = first_pnt;
			while (p != NULL)
			{
				next = (struct search_table *)p->forward_chain;
				free (p);
				p = next;
			}
			delete_node_db (db_sock, addr_db, MyNodeCall);
			usb_control_msg(udev, 0x40, SET_AD_RESET, ON, 0, buffer, 0, 100);	/* reset Node Adapter */
       			usb_close(udev);
			if (dprscomport != NULL) CloseHandle (dprscomport);
			closesocket(recv_sock);
			closesocket(send_sock);
			closesocket(db_sock);
			WSACleanup();
			printf ("\nEND TIME %s\n",curtime());
			abort();
		case 1:
			p = (struct search_table *)first_pnt->forward_chain;
			while (p != NULL)
			{
				next = (struct search_table *)p->forward_chain;
				free (p);
				p = next;
			}
			(struct search_table *)first_pnt->forward_chain = NULL;
			break;
		case 2:
			p = (struct search_table *)first_pnt->forward_chain;
			if (p == NULL)
			{
				printf ("No Entry\n");
				break;
			}
			printf ("\n");
			while (p != NULL)
			{
				printf ("%.8s %.8s %.8s %.3d.%.3d.%.3d.%.3d\n",
						p->d_table.CallSign,p->d_table.RPT1Call,p->d_table.RPT2Call,
						p->d_table.ip_address & 0xff,
						(p->d_table.ip_address >>  8) & 0xff,
						(p->d_table.ip_address >> 16) & 0xff,
						(p->d_table.ip_address >> 24) & 0xff);

				p = (struct search_table *)p->forward_chain;
			}
			break;

		default:
			break;
	}
	printf ("Return to Node program\n");
	signal (SIGINT, ctrl_c);
	signal (SIGBREAK, ctrl_c);
}

char *curtime(void)
{
	struct tm *pt;
	time_t	t;

	time (&t);
	pt = localtime (&t);
	return asctime(pt);
}


void	read_from_inet (struct timeval tv)	/* read from inet (UDP packet) */
{
	int	fromlen;
	int	leng;
	int	ret;
	int	timeout_wait;
	int	seq;

	fromlen = sizeof (struct sockaddr);

	FD_ZERO (&readfd);
	FD_SET (recv_sock, &readfd);
	ret = select(FD_SETSIZE, &readfd, NULL, NULL, &tv );
	if (ret)
	{
	  if (FD_ISSET(recv_sock, &readfd)) {
		leng = recvfrom (recv_sock, (char *)&recv_dv, 56, 0, (struct sockaddr *)&from, &fromlen);
		if (debug) printf ("\n*** length from INET %d\n",leng);			

		if (leng == 56)					/* RF header infomation */
		{
			if (Notice) printf ("%.19s Inet to RF %0.8s\n",curtime(), recv_dv.udp_p.rf_header.YourCall);
			from_ip = from.sin_addr.s_addr;
			if (keep_from_ip == 0)
			{
				keep_from_ip = from_ip;		/* new connection ? */
			}

			if (keep_from_ip == from_ip)
			{
				timeout_wait = 0;
				/* Check COS */
				usb_control_msg(udev, 0xC0, GET_AD_STATUS, 0, 0, &status, 1, 100);

				while (status & COS_OnOff)		/* until COS OFF */
				{
					Sleep (50);
					usb_control_msg(udev, 0xC0, GET_AD_STATUS, 0, 0, &status, 1, 100);
					timeout_wait += 1;
					if (timeout_wait > 40)	/* wait 2 seconds */
					{
						busy_packet_send ();
						break;
					}
				}

				if (!(status & COS_OnOff))
				{

				/* Callsign set */
				usb_control_msg(udev, 0x40, SET_MyCALL, 0, 0, recv_dv.udp_p.rf_header.MyCall, 8, 100);
			        usb_control_msg(udev, 0x40, SET_MyCALL2, 0, 0, recv_dv.udp_p.rf_header.MyCall2, 4, 100);
        			usb_control_msg(udev, 0x40, SET_YourCALL, 0, 0, recv_dv.udp_p.rf_header.YourCall, 8, 100);
   	    			usb_control_msg(udev, 0x40, SET_RPT1CALL, 0, 0, recv_dv.udp_p.rf_header.RPT1Call, 8, 100);
       				usb_control_msg(udev, 0x40, SET_RPT2CALL, 0, 0, recv_dv.udp_p.rf_header.RPT2Call, 8, 100);
			        usb_control_msg(udev, 0x40, SET_FLAGS, 0, 0, recv_dv.udp_p.rf_header.flags, 3, 100);

				if (debug || info) header_print (recv_dv, from_ip, 0);  
				addr_db.sin_port = htons(db_port);
				addr_db.sin_addr.s_addr = host_ip; 
				update_inet_addr (db_sock, addr_db, recv_dv.udp_p, from.sin_addr.s_addr, first_pnt);
			
				/* PTT ON */
				usb_control_msg(udev, 0x40, SET_PTT, ON, 0, buffer, 0, 100);
				VoicePacketCnt = 0;
				VoicePacketSW = FALSE;
				JitterBufferPnt = 0;
				PTT_ON = TRUE;
				}
			} else {	/* busy reply */
				if (PTT_ON) busy_packet_send();
			}			

		} else if (leng == 27) {			/* voice packet */
			from_ip = from.sin_addr.s_addr;
			if (keep_from_ip == 0)
			{
				keep_from_ip = from_ip;
			}
			if (keep_from_ip == from_ip)
			{
				if (DprsSW) dprs ((unsigned char *)&recv_dv.udp_p.dv_buff.buff[9]);
				if (debug) voice_packet_print (recv_dv, from_ip, 0);
//				SendVoicePacket2AD (recv_dv.udp_p.dv_buff.buff);
				seq = recv_dv.udp_p.b_bone.seq_high * 256 + recv_dv.udp_p.b_bone.seq_low;
				JitterBufferSave (recv_dv.udp_p.dv_buff.buff, seq); 
				if (!strncmp (recv_dv.udp_p.voice_d.data_segment,lastframe1,3)) LastFrameSW = 1;
				if (LastFrameSW)
				{
					if (!strncmp(recv_dv.udp_p.voice_d.voice_segment,lastframe2,3))
					{
						VoicePacketSW = TRUE;
						while (VoicePacketCnt) JitterBufferSend ();
						/* PTT OFF */
        					usb_control_msg(udev, 0x40, SET_PTT, OFF, 0, buffer, 0, 100);
						keep_from_ip = 0;
						PTTkeepalive = 0;
						VoicePacketCnt = 0;
						JitterBufferPnt = 0;
						VoicePacketSW = FALSE;
						PTT_ON = FALSE;
					}
					LastFrameSW = 0;
				}
			}
		} else if (leng == 36) {				/* IP retreval result */
			if (debug) search_ip_print (recv_dv);
			update_inet_adr (recv_dv.udp_d, first_pnt);
		} else if (leng == 16) {
			if (!strncmp(recv_dv.udp_d.req_id,"DI",2))	
			{
				sync = MsgPlay (sync, invalidfile);
			}
									/* delete from callsign table */
			if (debug) delete_callsign_print (recv_dv);
			delete_inet_adr (recv_dv.udp_d.req_callsign, first_pnt);
		} else if (leng == 8) {					/* STATUS FLAG */
			if (info || debug) printf ("Status : %.2x\n",recv_dv.udp_p.flags[1]); 
			if (recv_dv.udp_p.flags[1] & 0x01)
			{
				sync = MsgPlay(sync, busyfile);
			}			
		}
	  }
	}
	FD_CLR (recv_sock, &readfd);	
	return;
}

void	cfg_read(char FileName[])	/* read config. file */
{
	FILE	*cfg;
	char	buf[80],str[80];
	char	*token, *last;
	u_int	i;

	cfg = NULL;
	if (FileName != NULL)
	{
		cfg = fopen (FileName,"r");
		if (debug) printf ("\n*** Debug config file name : %s\n",FileName);
	}
	if (cfg == NULL)
	{
		cfg = fopen ("node.cfg","r");
		if (cfg == NULL)
		{
			printf ("CONFIG FILE NOT FOUND : %s\n",FileName);
			return;
		}
	}
	
	if (debug) printf ("\n*** Debug on Config File\n");
      
	while (fgets(buf, 80, cfg))
	{
		strcpy (str,buf);
		if (str[strlen(str)-1] == 0x0a) str[strlen(str)-1] = 0x00;
		token = str;
		for (i = 0 ; i < strlen(str) ; i++)
		{
			*token = toupper (*token);
			token++;
		}
		last = strpbrk (str,";");
		if (last == NULL)
		{
			printf ("CONFIG FILE ERROR : %s\n",buf);
		} else {
			*last = 0x00;
			token = str;
			while (*token == 0x20) token++;
			if (!strncmp (token,"MYNODECALLSIGN",14))
			{
				token = strpbrk(token,"\"");
				token++;
				last = strpbrk (token,"\"");
				if (last == NULL)
				{
					printf ("CONFIG FILE ERROR : %s\n",buf);
				} else {
					*last = 0x00;
					memset (MyNodeCall, 0x20, 8);
					strncpy (MyNodeCall,token, strlen(token));
					if (debug) printf ("MyNodeCall : %.8s\n",MyNodeCall);
				}
			} else if (!strncmp (token, "NODECALLCHECK", 13))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				if (!strncmp (token, "ON", 2))
				{
					NodeCallCheck = TRUE;
					NodeOn = FALSE;
				}
				if (debug) printf ("NodeCallCheck : %s\n",token);
			} else if (!strncmp (token, "SERVERNAME1", 11))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (server1, token);
				if (debug) printf ("ServerName1 : %s\n",server1);
			} else if (!strncmp (token, "SERVERNAME2", 11))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (server2, token);
				if (debug) printf ("ServerName2 : %s\n",server2);
			} else if (!strncmp (token, "SERVERNAME3", 11))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (server3, token);
				if (debug) printf ("ServerName3 : %s\n",server3);
			} else if (!strncmp (token, "MAXWAITSEC", 10))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				max_wait_sec = atoi(token);
				if (debug) printf ("MaxWaitSec : %d\n",max_wait_sec);
				max_wait_sec *= 5;
			} else if (!strncmp (token, "BUSYWAVEFILE", 12))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (busyfile, token);
				if (debug) printf ("BusyWaveFile : %s\n",busyfile);
			} else if (!strncmp (token, "NOTFOUNDWAVEFILE", 16))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (notfoundfile, token);
				if (debug) printf ("NotFoundfile : %s\n",notfoundfile);
			} else if (!strncmp (token, "INVALIDWAVEFILE", 15))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (invalidfile, token);
				if (debug) printf ("Invalidfile : %s\n",invalidfile);
			} else if (!strncmp (token, "AUDIOFILEDIR", 12))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (audiodir, token);
				if (debug) printf ("AudioFileDir : %s\n",audiodir);
			} else if (!strncmp (token, "MAXKEEPALIVE", 12))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				max_keep_alive = atoi(token);
				if (debug) printf ("MaxKeepAlive : %d\n",max_keep_alive);
			} else if (!strncmp (token, "MAXPTTKEEPALIVE", 15))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				maxPTTkeepalive = atoi(token);
				if (debug) printf ("MaxPTTKeepAlive : %d\n",maxPTTkeepalive);
				maxPTTkeepalive = maxPTTkeepalive / 25;
			} else if (!strncmp (token, "DPRSCOMPORT", 11))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (&DprsPortName[4], token);
				if (debug) printf ("DprsComPort : %s\n", &DprsPortName[4]);
			} else if (!strncmp (token, "DPRSSW", 6))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				if (!strncmp (token, "ON", 2))
				{
					DprsSW = TRUE;
				}
				if (debug) printf ("DprsSW : %s\n",token);
			} else if (!strncmp (token, "DPRSBAUDRATE", 12))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				baud_rate = atoi(token);
				if (debug) printf ("DprsBaud : %d\n",baud_rate);
			} else if (!strncmp (token, "DBPORT", 6))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				db_port = atoi(token);
				if (debug) printf ("DBPort : %d\n",db_port);
			} else if (!strncmp (token, "VOICEPORT", 9))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				voice_port = atoi(token);
				if (debug) printf ("VoicePort : %d\n",voice_port);
			} else if (!strncmp (token, "CRCCHECK", 8))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				if (!strncmp (token, "ON", 2))
				{
					CrcSW = TRUE;
				}
				if (debug) printf ("CRCcheck : %s\n",token);
			} else if (!strncmp (token, "ACCESSCONTROL", 13))
			{
				token = strpbrk(token,"=");
				token++;
				while (*token == 0x20) token++;
				strcpy (accessctrl, token);
				if (debug) printf ("AccessControl : %s\n",accessctrl);
			} else {
				printf ("CONFIG FILE ERROR : %s\n\n",buf);
			}
		} 			
	}
	fclose (cfg);
	if (debug) printf ("*** Debug Exit\n\n"); 
	return;
}


void	usage()
{
	printf ("Usage:\n\n");
	printf ("node [-?] [-d] [-i] [-f configfile]\n\n");
	printf ("-?  This Message\n");
	printf ("-d  Debug mode\n");
	printf ("-i  Information mode\n");
	printf ("-n  Notice\n");
	printf ("-f configfile configfle name \n");
	exit(0);
}

/* Version and Copyright info. */
void	print_version(void)
{
	printf ("D-STAR root server V%2.2x.%2.2x 09/22/2011\n",VersionHigh, VersionLow);
	printf (" (C) Satoshi Yasuda 7m3tjz/ad6gz\n");
	return;
}

void	Inet_SetUp()
{
        if (WSAStartup(2, &wsaData))
        {   printf("winsock initialize failed\n");
            abort();
        }

	recv_sock = socket(AF_INET, SOCK_DGRAM, 0);
        if (recv_sock == INVALID_SOCKET)
        {   printf("did not create sock\n");
            abort();
        }

	send_sock = socket(AF_INET, SOCK_DGRAM, 0);
        if (send_sock == INVALID_SOCKET)
        {   printf("did not create sock\n");
            abort();
        }

	db_sock = socket(AF_INET, SOCK_DGRAM, 0);
        if (db_sock == INVALID_SOCKET)
        {   printf("did not create sock\n");
            abort();
        }

	first_pnt =  malloc (sizeof(struct search_table));
	first_pnt->forward_chain = NULL;
	strncpy (first_pnt->d_table.CallSign, "********", 8);	/* dummy callsign */

	memset(&addr_out, 0, sizeof(addr_out));
	addr_out.sin_family = AF_INET;
	addr_out.sin_port = htons(voice_port);

	memset(&addr_in, 0, sizeof(addr_in));
	addr_in.sin_family = AF_INET;
	addr_in.sin_port = htons(voice_port);
	addr_in.sin_addr.s_addr = htonl(INADDR_ANY);

	bind(recv_sock, (struct sockaddr *)&addr_in, sizeof(addr_in));

	/* server address set */
	p_ent = gethostbyname(server1);
	if (p_ent == NULL)
	{
		p_ent = gethostbyname(server2);
	}
	if (p_ent == NULL)
	{
		p_ent = gethostbyname(server3);
		if (p_ent == NULL)
		{
			printf ("Server Not Found\n");
			return;
		}
	}
	p_in_addr = (struct in_addr *)p_ent->h_addr;
	if (info) printf("Server IP address : %s\n", inet_ntoa(*p_in_addr));

	memset(&addr_db, 0, sizeof(addr_db));
	addr_db.sin_family = AF_INET;
	addr_db.sin_port = htons(db_port);
	host_ip = inet_addr(inet_ntoa(*p_in_addr));
	addr_db.sin_addr.s_addr = host_ip;
	if (strncmp(MyNodeCall, "DIRECT  ", 8)) add_self_node_db (db_sock, addr_db);

	return;
}
